// CoopCustomizerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CoopCustomizer.h"
#include "CoopCustomizerDlg.h"
#include "CoopData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	/*
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	*/
	enum { IDD = IDD_ABOUTBOX };
	/*
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	*/
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoopCustomizerDlg dialog

CCoopCustomizerDlg::CCoopCustomizerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoopCustomizerDlg::IDD, pParent)
{
	/*
	//{{AFX_DATA_INIT(CCoopCustomizerDlg)
	*/
	m_battleship = FALSE;
	m_carrier = FALSE;
	m_destroyer = FALSE;
	m_dreadnought = FALSE;
	m_bpvratio = 0.0f;
	m_federation = FALSE;
	m_frigate = FALSE;
	m_heavy_battlecruiser = FALSE;
	m_heavy_cruiser = FALSE;
	m_light_cruiser = FALSE;
	m_new_heavy_cruiser = FALSE;
	m_war_destroyer = FALSE;
	m_gorn = FALSE;
	m_hydran = FALSE;
	m_isc = FALSE;
	m_klingon = FALSE;
	m_lyran = FALSE;
	m_mirak = FALSE;
	m_monster = FALSE;
	m_orion = FALSE;
	m_romulan = FALSE;
#ifdef OP
	m_OrionOrion = FALSE;
	m_Beastraiders = FALSE;
	m_WyldeFire = FALSE;
	m_Korgath = FALSE;
	m_Tigerheart = FALSE;
	m_Camboro = FALSE;
	m_Syndicate = FALSE;
	m_Prime = FALSE;
#endif
	m_race_use = _T("");
	m_ai_intel = -1;
#ifdef OP
	m_X1_support = FALSE;
	m_Xship_proportional = FALSE;
#endif
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCoopCustomizerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	/*
	//{{AFX_DATA_MAP(CCoopCustomizerDlg)
	*/
	DDX_Control(pDX, IDC_MONSTERODDS, m_ctlED_Monster);
	DDX_Control(pDX, IDC_FFODDS, m_ctlED_Frigate);
	DDX_Control(pDX, IDC_DDODDS, m_ctlED_Destroyer);
	DDX_Control(pDX, IDC_DWODDS, m_ctlED_WarDestroyer);
	DDX_Control(pDX, IDC_CLODDS, m_ctlED_LightCruiser);
	DDX_Control(pDX, IDC_CAODDS, m_ctlED_HeavyCruiser);
	DDX_Control(pDX, IDC_NCAODDS, m_ctlED_NewHeavyCruiser);
	DDX_Control(pDX, IDC_BCHODDS, m_ctlED_HeavyBattlecruiser);
	DDX_Control(pDX, IDC_CVODDS, m_ctlED_Carrier);
	DDX_Control(pDX, IDC_DNODDS, m_ctlED_Dreadnought);
	DDX_Control(pDX, IDC_BBODDS, m_ctlED_Battleship);
	DDX_Control(pDX, IDC_SLIDER, m_slider);

	DDX_Control(pDX, IDC_EARLY, m_early);
	DDX_Control(pDX, IDC_MIDDLE, m_middle);
	DDX_Control(pDX, IDC_LATE, m_late);
#ifdef OP
	DDX_Control(pDX, IDC_ADVANCED, m_advanced);
	DDX_Control(pDX, IDC_ERA_GAME_USE, m_era_game_use);
#endif

	DDX_Check(pDX, IDC_BATTLESHIP, m_battleship);
	DDX_Check(pDX, IDC_CARRIER, m_carrier);
	DDX_Check(pDX, IDC_DESTROYER, m_destroyer);
	DDX_Check(pDX, IDC_DREADNOUGHT, m_dreadnought);
	DDX_Text(pDX, IDC_ENEMYRATIO, m_bpvratio);
	DDX_Check(pDX, IDC_FEDERATION, m_federation);
	DDX_Check(pDX, IDC_FRIGATE, m_frigate);
	DDX_Check(pDX, IDC_HEAVYBATTLECRUISER, m_heavy_battlecruiser);
	DDX_Check(pDX, IDC_HEAVYCRUISER, m_heavy_cruiser);
	DDX_Check(pDX, IDC_LIGHTCRUISER, m_light_cruiser);
	DDX_Check(pDX, IDC_NEWHEAVYCRUISER, m_new_heavy_cruiser);
	DDX_Check(pDX, IDC_WARDESTROYER, m_war_destroyer);
	DDX_Check(pDX, IDC_GORN,		m_gorn);
	DDX_Check(pDX, IDC_HYDRAN,		m_hydran);
	DDX_Check(pDX, IDC_ISC,			m_isc);
	DDX_Check(pDX, IDC_KLINGON,		m_klingon);
	DDX_Check(pDX, IDC_LYRAN,		m_lyran);
	DDX_Check(pDX, IDC_MIRAK,		m_mirak);
	DDX_Check(pDX, IDC_MONSTER,		m_monster);
	DDX_Check(pDX, IDC_ORION,		m_orion);
	DDX_Check(pDX, IDC_ROMULAN,		m_romulan);
#ifdef OP
	DDX_Check(pDX, IDC_OrionOrion,	m_OrionOrion);
	DDX_Check(pDX, IDC_Beastraiders, m_Beastraiders);
	DDX_Check(pDX, IDC_WyldeFire,	m_WyldeFire);
	DDX_Check(pDX, IDC_Korgath,		m_Korgath);
	DDX_Check(pDX, IDC_Tigerheart,	m_Tigerheart);
	DDX_Check(pDX, IDC_Camboro,		m_Camboro);
	DDX_Check(pDX, IDC_Syndicate,	m_Syndicate);
	DDX_Check(pDX, IDC_Prime,		m_Prime);
#endif
	DDX_CBString(pDX, IDC_RACEUSE, m_race_use);
	DDX_CBIndex(pDX, IDC_AI_INTEL, m_ai_intel);
#ifdef OP
	DDX_Check(pDX, IDC_X1_support,	m_X1_support);
	DDX_Check(pDX, IDC_Xship_proportional,		m_Xship_proportional);
	DDX_Check(pDX, IDC_upgrade_AI_fighters,		m_upgrade_AI_fighters);
#endif
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCoopCustomizerDlg, CDialog)
	/*
	//{{AFX_MSG_MAP(CCoopCustomizerDlg)
	*/
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DEFAULTS, OnDefaults)
	ON_CBN_SELCHANGE(IDC_RACEUSE, OnSelchangeRaceuse)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDER, OnReleasedcaptureSlider)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BATTLESHIP, OnBattleship)
	ON_BN_CLICKED(IDC_CARRIER, OnCarrier)
	ON_BN_CLICKED(IDC_DESTROYER, OnDestroyer)
	ON_BN_CLICKED(IDC_DREADNOUGHT, OnDreadnought)
	ON_BN_CLICKED(IDC_FRIGATE, OnFrigate)
	ON_BN_CLICKED(IDC_HEAVYBATTLECRUISER, OnHeavybattlecruiser)
	ON_BN_CLICKED(IDC_HEAVYCRUISER, OnHeavycruiser)
	ON_BN_CLICKED(IDC_LIGHTCRUISER, OnLightcruiser)
	ON_BN_CLICKED(IDC_NEWHEAVYCRUISER, OnNewheavycruiser)
	ON_BN_CLICKED(IDC_WARDESTROYER, OnWardestroyer)
	ON_BN_CLICKED(IDC_MONSTER, OnMonster)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoopCustomizerDlg message handlers

BOOL CCoopCustomizerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_ctlED_Frigate.LimitText( 3 );
	m_ctlED_Destroyer.LimitText( 3 );
	m_ctlED_WarDestroyer.LimitText( 3 );
	m_ctlED_LightCruiser.LimitText( 3 );
	m_ctlED_HeavyCruiser.LimitText( 3 );
	m_ctlED_NewHeavyCruiser.LimitText( 3 );
	m_ctlED_HeavyBattlecruiser.LimitText( 3 );
	m_ctlED_Carrier.LimitText( 3 );
	m_ctlED_Dreadnought.LimitText( 3 );
	m_ctlED_Battleship.LimitText( 3 );

	m_ctlED_Monster.LimitText( 3 );

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_slider.SetRange(-50, 200);	// 0.50 through 3.00, starting at 1.00
	m_slider.SetLineSize(1);
	m_slider.SetPageSize(10);

	if (!gCoopData.Load())
	{
		char err[256];
		sprintf(err, "Error reading from scripts.ini; code %d.", GetLastError());
		MessageBox(err);
		return FALSE;
	}

	m_bpvratio = gCoopData.mGetEnemyBPVRatio();
	int pos = (m_bpvratio * 100) - 100;
	m_slider.SetPos(pos);
	m_slider.SetRange(-50, 200, TRUE);	// 0.50 through 3.00, starting at 1.00
	
	if (gCoopData.mIsRaceRandom())
		m_race_use = _T("Mixed");
	else
		m_race_use = _T("Single");

	
	m_battleship = gCoopData.mIsShipClassSelected(kClassBattleship);
	m_carrier = gCoopData.mIsShipClassSelected(kClassCarrier);
	m_destroyer = gCoopData.mIsShipClassSelected(kClassDestroyer);
	m_dreadnought = gCoopData.mIsShipClassSelected(kClassDreadnought);
	m_frigate = gCoopData.mIsShipClassSelected(kClassFrigate);
	m_heavy_battlecruiser = gCoopData.mIsShipClassSelected(kClassHeavyBattlecruiser);
	m_heavy_cruiser = gCoopData.mIsShipClassSelected(kClassHeavyCruiser);
	m_light_cruiser = gCoopData.mIsShipClassSelected(kClassLightCruiser);
	m_new_heavy_cruiser = gCoopData.mIsShipClassSelected(kClassNewHeavyCruiser);
	m_war_destroyer = gCoopData.mIsShipClassSelected(kClassWarDestroyer);

	CButton* lpCHK = NULL;
	lpCHK = ((CButton*)(GetDlgItem( IDC_BATTLESHIP )));			lpCHK->SetCheck( m_battleship );			m_ctlED_Battleship.EnableWindow( m_battleship );
	lpCHK = ((CButton*)(GetDlgItem( IDC_CARRIER )));			lpCHK->SetCheck( m_carrier );				m_ctlED_Carrier.EnableWindow( m_carrier );
	lpCHK = ((CButton*)(GetDlgItem( IDC_DESTROYER )));			lpCHK->SetCheck( m_destroyer );				m_ctlED_Destroyer.EnableWindow( m_destroyer );
	lpCHK = ((CButton*)(GetDlgItem( IDC_DREADNOUGHT )));		lpCHK->SetCheck( m_dreadnought );			m_ctlED_Dreadnought.EnableWindow( m_dreadnought );
	lpCHK = ((CButton*)(GetDlgItem( IDC_FRIGATE )));			lpCHK->SetCheck( m_frigate );				m_ctlED_Frigate.EnableWindow( m_frigate );
	lpCHK = ((CButton*)(GetDlgItem( IDC_HEAVYBATTLECRUISER )));	lpCHK->SetCheck( m_heavy_battlecruiser );	m_ctlED_HeavyBattlecruiser.EnableWindow( m_heavy_battlecruiser );
	lpCHK = ((CButton*)(GetDlgItem( IDC_HEAVYCRUISER )));		lpCHK->SetCheck( m_heavy_cruiser );			m_ctlED_HeavyCruiser.EnableWindow( m_heavy_cruiser );
	lpCHK = ((CButton*)(GetDlgItem( IDC_LIGHTCRUISER )));		lpCHK->SetCheck( m_light_cruiser );			m_ctlED_LightCruiser.EnableWindow( m_light_cruiser );
	lpCHK = ((CButton*)(GetDlgItem( IDC_NEWHEAVYCRUISER )));	lpCHK->SetCheck( m_new_heavy_cruiser );		m_ctlED_NewHeavyCruiser.EnableWindow( m_new_heavy_cruiser );
	lpCHK = ((CButton*)(GetDlgItem( IDC_WARDESTROYER )));		lpCHK->SetCheck( m_war_destroyer );			m_ctlED_WarDestroyer.EnableWindow( m_war_destroyer );

	m_federation = gCoopData.mIsRaceSelected(kFederation);
	m_gorn = gCoopData.mIsRaceSelected(kGorn);
	m_hydran = gCoopData.mIsRaceSelected(kHydran);
	m_isc = gCoopData.mIsRaceSelected(kISC);
	m_klingon = gCoopData.mIsRaceSelected(kKlingon);
	m_lyran = gCoopData.mIsRaceSelected(kLyran);
	m_mirak = gCoopData.mIsRaceSelected(kMirak);
	m_monster = gCoopData.mIsRaceSelected(kMonster);
	m_orion = gCoopData.mIsRaceSelected(kOrion);
	m_romulan = gCoopData.mIsRaceSelected(kRomulan);
#ifdef OP
	m_OrionOrion = gCoopData.mIsRaceSelected(kOrionOrion);
	m_Syndicate = gCoopData.mIsRaceSelected(kOrionSyndicate);
	m_Beastraiders = gCoopData.mIsRaceSelected(kOrionBeastRaiders);
	m_WyldeFire = gCoopData.mIsRaceSelected(kOrionWyldeFire);
	m_Korgath = gCoopData.mIsRaceSelected(kOrionKorgath);
	m_Tigerheart = gCoopData.mIsRaceSelected(kOrionTigerHeart);
	m_Camboro = gCoopData.mIsRaceSelected(kOrionCamboro);
	m_Prime = gCoopData.mIsRaceSelected(kOrionPrime);
#endif
	TCHAR arszBuffer[ 16 ];
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pFF) );		m_ctlED_Frigate.SetWindowText( arszBuffer );			m_ctlED_Frigate.EnableWindow( m_frigate );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pDD) );		m_ctlED_Destroyer.SetWindowText( arszBuffer );			m_ctlED_Destroyer.EnableWindow( m_destroyer );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pDW) );		m_ctlED_WarDestroyer.SetWindowText( arszBuffer );		m_ctlED_WarDestroyer.EnableWindow( m_war_destroyer );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pCL) );		m_ctlED_LightCruiser.SetWindowText( arszBuffer );		m_ctlED_LightCruiser.EnableWindow( m_light_cruiser );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pCA) );		m_ctlED_HeavyCruiser.SetWindowText( arszBuffer );		m_ctlED_HeavyCruiser.EnableWindow( m_heavy_cruiser );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pNCA) );		m_ctlED_NewHeavyCruiser.SetWindowText( arszBuffer );	m_ctlED_NewHeavyCruiser.EnableWindow( m_new_heavy_cruiser );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pBCH) );		m_ctlED_HeavyBattlecruiser.SetWindowText( arszBuffer );	m_ctlED_HeavyBattlecruiser.EnableWindow( m_heavy_battlecruiser );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pCV) );		m_ctlED_Carrier.SetWindowText( arszBuffer );			m_ctlED_Carrier.EnableWindow( m_carrier );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pDN) );		m_ctlED_Dreadnought.SetWindowText( arszBuffer );		m_ctlED_Dreadnought.EnableWindow( m_dreadnought );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pBB) );		m_ctlED_Battleship.SetWindowText( arszBuffer );			m_ctlED_Battleship.EnableWindow( m_battleship );
	_stprintf( arszBuffer, _T( "%d" ), gCoopData.mGetShipOdds(pMON) );		m_ctlED_Monster.SetWindowText( arszBuffer );			m_ctlED_Monster.EnableWindow( m_monster && (m_race_use == "Mixed"));

#ifdef OP
	m_X1_support = gCoopData.mGetX1Support();
	m_Xship_proportional = gCoopData.mGetXship_proportional();
	m_upgrade_AI_fighters = gCoopData.mGet_upgrade_AI_fighters();
#endif

/* set the era radiobutton */
#ifdef EAW
UINT nID;
switch(gCoopData.mGetEra()){
	case  kEarly:
			nID = IDC_EARLY;
			break;
	case  kMiddle:
			nID = IDC_MIDDLE;
			break;
	default :
			nID = IDC_LATE;
			break;
}
	CheckRadioButton(IDC_EARLY, IDC_LATE, nID);
#else
UINT nID;
switch(gCoopData.mGetEra()){
	case  kEarly:
			nID = IDC_EARLY;
			break;
	case  kMiddle:
			nID = IDC_MIDDLE;
			break;
	case  kLate:
			nID = IDC_LATE;
			break;
	case  kAdvanced:
			nID = IDC_ADVANCED;
			break;
	default :
			nID = IDC_ERA_GAME_USE;
			break;
}
	CheckRadioButton(IDC_EARLY, IDC_ERA_GAME_USE, nID);
#endif


	/*
	 * Handle AI Intelligence
	 */
	
	m_ai_intel = gCoopData.mGetAIIntel();

	UpdateData(FALSE);		// push
	OnSelchangeRaceuse();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCoopCustomizerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCoopCustomizerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCoopCustomizerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCoopCustomizerDlg::OnDefaults() 
{
	// TODO: Add your control notification handler code here
	
	m_bpvratio = 1.1f;
	m_ai_intel = 1;				// Commodore
	m_slider.SetPos(10);
	m_race_use = "Single"; gCoopData.mSetGametype(Single);

	m_battleship = TRUE;
	m_carrier = TRUE;
	m_destroyer = TRUE;
	m_dreadnought = TRUE;
	m_frigate = TRUE;
	m_heavy_battlecruiser = TRUE;
	m_heavy_cruiser = TRUE;
	m_light_cruiser = TRUE;
	m_new_heavy_cruiser = TRUE;
	m_war_destroyer = TRUE;


	TCHAR arszBuffer[ 16 ];
	_stprintf( arszBuffer, _T( "%d" ), ff_percentage );		m_ctlED_Frigate.SetWindowText( arszBuffer );			m_ctlED_Frigate.EnableWindow( m_frigate );
	_stprintf( arszBuffer, _T( "%d" ), dd_percentage );		m_ctlED_Destroyer.SetWindowText( arszBuffer );			m_ctlED_Destroyer.EnableWindow( m_destroyer );
	_stprintf( arszBuffer, _T( "%d" ), wd_percentage );		m_ctlED_WarDestroyer.SetWindowText( arszBuffer );		m_ctlED_WarDestroyer.EnableWindow( m_war_destroyer );
	_stprintf( arszBuffer, _T( "%d" ), cl_percentage );		m_ctlED_LightCruiser.SetWindowText( arszBuffer );		m_ctlED_LightCruiser.EnableWindow( m_light_cruiser );
	_stprintf( arszBuffer, _T( "%d" ), ca_percentage );		m_ctlED_HeavyCruiser.SetWindowText( arszBuffer );		m_ctlED_HeavyCruiser.EnableWindow( m_heavy_cruiser );
	_stprintf( arszBuffer, _T( "%d" ), nca_percentage );	m_ctlED_NewHeavyCruiser.SetWindowText( arszBuffer );	m_ctlED_NewHeavyCruiser.EnableWindow( m_new_heavy_cruiser );
	_stprintf( arszBuffer, _T( "%d" ), bch_percentage );	m_ctlED_HeavyBattlecruiser.SetWindowText( arszBuffer );	m_ctlED_HeavyBattlecruiser.EnableWindow( m_heavy_battlecruiser );
	_stprintf( arszBuffer, _T( "%d" ), cv_percentage );		m_ctlED_Carrier.SetWindowText( arszBuffer );			m_ctlED_Carrier.EnableWindow( m_carrier );
	_stprintf( arszBuffer, _T( "%d" ), dn_percentage );		m_ctlED_Dreadnought.SetWindowText( arszBuffer );		m_ctlED_Dreadnought.EnableWindow( m_dreadnought );
	_stprintf( arszBuffer, _T( "%d" ), bb_percentage );		m_ctlED_Battleship.SetWindowText( arszBuffer );			m_ctlED_Battleship.EnableWindow( m_battleship );
	_stprintf( arszBuffer, _T( "%d" ), monster_percentage );m_ctlED_Monster.SetWindowText( arszBuffer );			m_ctlED_Monster.EnableWindow( m_monster && (m_race_use == "Mixed"));

	m_gorn = TRUE;
	m_hydran = TRUE;
	m_isc = TRUE;
	m_klingon = TRUE;
	m_lyran = TRUE;
	m_mirak = TRUE;
	m_monster = TRUE;
	m_orion = TRUE;
	m_romulan = TRUE;
	m_federation = TRUE;
#ifdef OP
	m_Syndicate = TRUE;
	m_Beastraiders = TRUE;
	m_WyldeFire = TRUE;
	m_Korgath = TRUE;
	m_Tigerheart = TRUE;
	m_Camboro = TRUE;
	m_Prime = TRUE;
	m_OrionOrion = TRUE;
#endif

#ifdef OP
	m_X1_support = TRUE;
	m_Xship_proportional = TRUE;
	m_upgrade_AI_fighters = TRUE;

	UINT nID = IDC_ERA_GAME_USE;
	CheckRadioButton(IDC_EARLY, IDC_ERA_GAME_USE, nID);
#endif
#ifdef EAW
	UINT nID = IDC_LATE;
	CheckRadioButton(IDC_EARLY, IDC_LATE, nID);
#endif

	UpdateData(FALSE);		// push data to dialog
	OnSelchangeRaceuse();
	
	
}


void CCoopCustomizerDlg::OnSelchangeRaceuse() 
{
	// TODO: Add your control notification handler code here
	//
UpdateData(TRUE);
	gCoopData.mResetRaceSelections();
		if (m_federation) gCoopData.mSetRaceSelected(kFederation);
		if (m_gorn) gCoopData.mSetRaceSelected(kGorn);
		if (m_hydran) gCoopData.mSetRaceSelected(kHydran);
		if (m_isc) gCoopData.mSetRaceSelected(kISC);
		if (m_klingon) gCoopData.mSetRaceSelected(kKlingon);
		if (m_lyran) gCoopData.mSetRaceSelected(kLyran);
		if (m_mirak) gCoopData.mSetRaceSelected(kMirak);
		if (m_monster) gCoopData.mSetRaceSelected(kMonster);
		if (m_orion) gCoopData.mSetRaceSelected(kOrion);
		if (m_romulan) gCoopData.mSetRaceSelected(kRomulan);
#ifdef OP
		if (m_OrionOrion) gCoopData.mSetRaceSelected(kOrionOrion);
		if (m_Syndicate) gCoopData.mSetRaceSelected(kOrionSyndicate);
		if (m_Beastraiders) gCoopData.mSetRaceSelected(kOrionBeastRaiders);
		if (m_WyldeFire) gCoopData.mSetRaceSelected(kOrionWyldeFire);
		if (m_Korgath) gCoopData.mSetRaceSelected(kOrionKorgath);
		if (m_Tigerheart) gCoopData.mSetRaceSelected(kOrionTigerHeart);
		if (m_Camboro) gCoopData.mSetRaceSelected(kOrionCamboro);
		if (m_Prime) gCoopData.mSetRaceSelected(kOrionPrime);
#endif
		if(m_race_use == "Single")
			gCoopData.mSetGametype(Single);
		else
			gCoopData.mSetGametype(Mixed);

#ifdef OP
		if (m_X1_support) gCoopData.mSetX1Support(m_X1_support);
		if (m_Xship_proportional) gCoopData.mSetXship_proportional(m_Xship_proportional);
		if (m_upgrade_AI_fighters) gCoopData.mSet_upgrade_AI_fighters(m_upgrade_AI_fighters);
#endif

	//UpdateData(TRUE);
	m_federation = gCoopData.mIsRaceSelected(kFederation);
	m_gorn = gCoopData.mIsRaceSelected(kGorn);
	m_hydran = gCoopData.mIsRaceSelected(kHydran);
	m_isc = gCoopData.mIsRaceSelected(kISC);
	m_klingon = gCoopData.mIsRaceSelected(kKlingon);
	m_lyran = gCoopData.mIsRaceSelected(kLyran);
	m_mirak = gCoopData.mIsRaceSelected(kMirak);
	m_monster = gCoopData.mIsRaceSelected(kMonster);
	m_orion = gCoopData.mIsRaceSelected(kOrion);
	m_romulan = gCoopData.mIsRaceSelected(kRomulan);
#ifdef OP
	m_OrionOrion = gCoopData.mIsRaceSelected(kOrionOrion);
	m_Syndicate = gCoopData.mIsRaceSelected(kOrionSyndicate);
	m_Beastraiders = gCoopData.mIsRaceSelected(kOrionBeastRaiders);
	m_WyldeFire = gCoopData.mIsRaceSelected(kOrionWyldeFire);
	m_Korgath = gCoopData.mIsRaceSelected(kOrionKorgath);
	m_Tigerheart = gCoopData.mIsRaceSelected(kOrionTigerHeart);
	m_Camboro = gCoopData.mIsRaceSelected(kOrionCamboro);
	m_Prime = gCoopData.mIsRaceSelected(kOrionPrime);
#endif

			/*GetDlgItem(IDC_FEDERATION)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_KLINGON)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_ROMULAN)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_GORN)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_LYRAN)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_HYDRAN)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_MIRAK)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_ISC)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_ORION)->EnableWindow(m_race_use != "Single");
	GetDlgItem(IDC_MONSTER)->EnableWindow(m_race_use != "Single");*/
	m_ctlED_Monster.EnableWindow( m_monster && (m_race_use == "Mixed"));
UpdateData(FALSE);
//	char debug[128];
//	sprintf(debug, "End of onsel. Gametype is %d", gCoopData.mIsRaceRandom() );
//	MessageBox( debug, "Onsel", MB_OK); 
//	ToggleEditControl( IDC_MONSTER, &m_ctlED_Monster );

}

void CCoopCustomizerDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	UpdateData(TRUE);

	gCoopData.mSetEnemyBPVRatio(m_bpvratio);
	gCoopData.mResetRaceSelections();
	if (m_race_use == "Mixed")
	{ 
		gCoopData.mSetGametype(Mixed);
	}
	else{
		gCoopData.mSetGametype(Single);
	}
		if (m_federation) gCoopData.mSetRaceSelected(kFederation);
		if (m_gorn) gCoopData.mSetRaceSelected(kGorn);
		if (m_hydran) gCoopData.mSetRaceSelected(kHydran);
		if (m_isc) gCoopData.mSetRaceSelected(kISC);
		if (m_klingon) gCoopData.mSetRaceSelected(kKlingon);
		if (m_lyran) gCoopData.mSetRaceSelected(kLyran);
		if (m_mirak) gCoopData.mSetRaceSelected(kMirak);
		if (m_monster) gCoopData.mSetRaceSelected(kMonster);
		if (m_orion) gCoopData.mSetRaceSelected(kOrion);
		if (m_romulan) gCoopData.mSetRaceSelected(kRomulan);
#ifdef OP
		if (m_OrionOrion) gCoopData.mSetRaceSelected(kOrionOrion);
		if (m_Syndicate) gCoopData.mSetRaceSelected(kOrionSyndicate);
		if (m_Beastraiders) gCoopData.mSetRaceSelected(kOrionBeastRaiders);
		if (m_WyldeFire) gCoopData.mSetRaceSelected(kOrionWyldeFire);
		if (m_Korgath) gCoopData.mSetRaceSelected(kOrionKorgath);
		if (m_Tigerheart) gCoopData.mSetRaceSelected(kOrionTigerHeart);
		if (m_Camboro) gCoopData.mSetRaceSelected(kOrionCamboro);
		if (m_Prime) gCoopData.mSetRaceSelected(kOrionPrime);
#endif

#ifdef OP
		gCoopData.mSetX1Support(m_X1_support);
		gCoopData.mSetXship_proportional(m_Xship_proportional);
		gCoopData.mSet_upgrade_AI_fighters(m_upgrade_AI_fighters);
#endif

//	}
		char oddsBuffer[4]={NULL, NULL, NULL, NULL};
	gCoopData.mResetShipClassSelections();
	if (m_battleship) gCoopData.mSetShipClassSelected(kClassBattleship);
	m_ctlED_Battleship.GetWindowText(oddsBuffer, 4);	gCoopData.mSetShipOdds(pBB, atoi(oddsBuffer));
	if (m_carrier) gCoopData.mSetShipClassSelected(kClassCarrier);
	m_ctlED_Carrier.GetWindowText(oddsBuffer, 4);		gCoopData.mSetShipOdds(pCV, atoi(oddsBuffer));
	if (m_destroyer) gCoopData.mSetShipClassSelected(kClassDestroyer);
	m_ctlED_Destroyer.GetWindowText(oddsBuffer, 4);	gCoopData.mSetShipOdds(pDD, atoi(oddsBuffer));
	if (m_dreadnought) gCoopData.mSetShipClassSelected(kClassDreadnought);
	m_ctlED_Dreadnought.GetWindowText(oddsBuffer, 4);	gCoopData.mSetShipOdds(pDN, atoi(oddsBuffer));
	if (m_frigate) gCoopData.mSetShipClassSelected(kClassFrigate);
	m_ctlED_Frigate.GetWindowText(oddsBuffer,4);		gCoopData.mSetShipOdds(pFF, atoi(oddsBuffer));
	if (m_heavy_battlecruiser) gCoopData.mSetShipClassSelected(kClassHeavyBattlecruiser);
	m_ctlED_HeavyBattlecruiser.GetWindowText(oddsBuffer,4);	gCoopData.mSetShipOdds(pBCH, atoi(oddsBuffer));
	if (m_heavy_cruiser) gCoopData.mSetShipClassSelected(kClassHeavyCruiser);
	m_ctlED_HeavyCruiser.GetWindowText(oddsBuffer,4);	gCoopData.mSetShipOdds(pCA, atoi(oddsBuffer));
	if (m_light_cruiser) gCoopData.mSetShipClassSelected(kClassLightCruiser);
	m_ctlED_LightCruiser.GetWindowText(oddsBuffer,4);	gCoopData.mSetShipOdds(pCL, atoi(oddsBuffer));
	if (m_new_heavy_cruiser) gCoopData.mSetShipClassSelected(kClassNewHeavyCruiser);
	m_ctlED_NewHeavyCruiser.GetWindowText(oddsBuffer,4);		gCoopData.mSetShipOdds(pNCA, atoi(oddsBuffer));
	if (m_war_destroyer) gCoopData.mSetShipClassSelected(kClassWarDestroyer);
	m_ctlED_WarDestroyer.GetWindowText(oddsBuffer,4);				gCoopData.mSetShipOdds(pDW, atoi(oddsBuffer));
	m_ctlED_Monster.GetWindowText(oddsBuffer,4);		gCoopData.mSetShipOdds(pMON, atoi(oddsBuffer));


	/* get the radio button setting */
#ifdef EAW
	switch(GetCheckedRadioButton(IDC_EARLY, IDC_LATE)){
		case IDC_EARLY:
			gCoopData.mSetEra(kEarly);
			break;
		case IDC_MIDDLE:
			gCoopData.mSetEra(kMiddle);
			break;
		default:
			gCoopData.mSetEra(kLate);
			break;
	}
#endif


#ifdef OP
	switch(GetCheckedRadioButton(IDC_EARLY, IDC_ADVANCED)){
		case IDC_EARLY:
			gCoopData.mSetEra(kEarly);
			break;
		case IDC_MIDDLE:
			gCoopData.mSetEra(kMiddle);
			break;
		case IDC_LATE:
			gCoopData.mSetEra(kLate);
			break;
		case IDC_ADVANCED:
			gCoopData.mSetEra(kAdvanced);
			break;
		default:
			gCoopData.mSetEra(kEra_Game_Use);
			break;
	}
#endif

	//
	// Also handle the AI
	//

	gCoopData.mSetAIIntel(m_ai_intel);
	
	if (!gCoopData.Save())
	{
		char err[256];
		sprintf(err, "Error saving to scripts.ini; code %d.", GetLastError());
		MessageBox(err);
	}

	if (gCoopData.mGetRawRaceSelected())
		CDialog::OnOK();
	else
	{
		char debug[128];
		sprintf(debug, "You must select at least one race to continue." );
		MessageBox( debug, "No race selected!", MB_OK); 
	}

}

void CCoopCustomizerDlg::OnReleasedcaptureSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void CCoopCustomizerDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default

	CSliderCtrl *	slider = (CSliderCtrl *)pScrollBar;
	UpdateData(TRUE);

	INT pos = (INT)nPos;

	switch (nSBCode)
	{
		case SB_LEFT:		m_bpvratio = 0.5f; break;
		case SB_LINELEFT:	m_bpvratio -= 0.01f; if (m_bpvratio < 0.50f) m_bpvratio = 0.50f; break;
		case SB_LINERIGHT:	m_bpvratio += 0.01f; if (m_bpvratio > 3.00f) m_bpvratio = 3.00f; break;
		case SB_PAGELEFT:	m_bpvratio -= 0.1f; if (m_bpvratio < 0.50f) m_bpvratio = 0.50f; break;
		case SB_PAGERIGHT:	m_bpvratio += 0.1f; if (m_bpvratio > 3.00f) m_bpvratio = 3.00f; break;
		case SB_RIGHT:		m_bpvratio = 3.00f; break;

		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:		m_bpvratio = 1.00f + ((float)pos / 100.0f);
								break;
	}

	UpdateData(FALSE);

//	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CCoopCustomizerDlg::OnCartels() 
{
	// TODO: Add your control notification handler code here
	
}

void CCoopCustomizerDlg::OnBattleship() 
{
	ToggleEditControl( IDC_BATTLESHIP, &m_ctlED_Battleship );
}

void CCoopCustomizerDlg::OnCarrier() 
{
	ToggleEditControl( IDC_CARRIER, &m_ctlED_Carrier );
}

void CCoopCustomizerDlg::OnDestroyer() 
{
	ToggleEditControl( IDC_DESTROYER, &m_ctlED_Destroyer );
}

void CCoopCustomizerDlg::OnDreadnought() 
{
	ToggleEditControl( IDC_DREADNOUGHT, &m_ctlED_Dreadnought );
}

void CCoopCustomizerDlg::OnFrigate() 
{
	ToggleEditControl( IDC_FRIGATE, &m_ctlED_Frigate );
}

void CCoopCustomizerDlg::OnHeavybattlecruiser() 
{
	ToggleEditControl( IDC_HEAVYBATTLECRUISER, &m_ctlED_HeavyBattlecruiser );
}

void CCoopCustomizerDlg::OnHeavycruiser() 
{
	ToggleEditControl( IDC_HEAVYCRUISER, &m_ctlED_HeavyCruiser );
}

void CCoopCustomizerDlg::OnLightcruiser() 
{
	ToggleEditControl( IDC_LIGHTCRUISER, &m_ctlED_LightCruiser );
}

void CCoopCustomizerDlg::OnNewheavycruiser() 
{
	ToggleEditControl( IDC_NEWHEAVYCRUISER, &m_ctlED_NewHeavyCruiser );
}

void CCoopCustomizerDlg::OnWardestroyer() 
{
	ToggleEditControl( IDC_WARDESTROYER, &m_ctlED_WarDestroyer );
}

void CCoopCustomizerDlg::OnMonster() 
{	UpdateData(TRUE);
/*	char debug[128];
	sprintf(debug, "m_monster is %d and m_race_use is %s. Gametype is %d", m_monster, m_race_use, gCoopData.mIsRaceRandom() );
	MessageBox( debug, "Onmonster", MB_OK);*/
//	ToggleEditControl( IDC_MONSTER, &m_ctlED_Monster );
	m_ctlED_Monster.EnableWindow( m_monster && (m_race_use == "Mixed"));

	

}

void CCoopCustomizerDlg::ToggleEditControl( UINT nID, CWnd* lpEditControl )
{
	int nStatus = ((CButton*)(GetDlgItem( nID )))->GetCheck();
	lpEditControl->EnableWindow( nStatus );
}


