// CoopCustomizerDlg.h : header file
//



#if !defined(AFX_COOPCUSTOMIZERDLG_H__1481F34C_C890_461F_8CA8_4AD046F3C5B4__INCLUDED_)
#define AFX_COOPCUSTOMIZERDLG_H__1481F34C_C890_461F_8CA8_4AD046F3C5B4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCoopCustomizerDlg dialog
#include "DigitsEdit.h"
#include "CoopData.h"

class CCoopCustomizerDlg : public CDialog
{
// Construction
public:
	CCoopCustomizerDlg(CWnd* pParent = NULL);	// standard constructor
	void ToggleEditControl( UINT nID, CWnd* lpEditControl );

	/*
	// Dialog Data
	//{{AFX_DATA(CCoopCustomizerDlg)
	*/

	enum { IDD = IDD_COOPCUSTOMIZER_DIALOG };
	CDigitsEdit	m_ctlED_Monster;
	CDigitsEdit	m_ctlED_Frigate;
	CDigitsEdit	m_ctlED_Destroyer;
	CDigitsEdit	m_ctlED_WarDestroyer;
	CDigitsEdit	m_ctlED_LightCruiser;
	CDigitsEdit	m_ctlED_HeavyCruiser;
	CDigitsEdit	m_ctlED_NewHeavyCruiser;
	CDigitsEdit	m_ctlED_HeavyBattlecruiser;
	CDigitsEdit	m_ctlED_Carrier;
	CDigitsEdit	m_ctlED_Dreadnought;
	CDigitsEdit	m_ctlED_Battleship;
	CSliderCtrl	m_slider;

	CButton m_early;
	CButton m_middle;
	CButton m_late;
#ifdef OP
	CButton m_advanced;
	CButton m_era_game_use;
#endif

	BOOL	m_battleship;
	BOOL	m_carrier;
	BOOL	m_destroyer;
	BOOL	m_dreadnought;
	float	m_bpvratio;
	BOOL	m_federation;
	BOOL	m_frigate;
	BOOL	m_heavy_battlecruiser;
	BOOL	m_heavy_cruiser;
	BOOL	m_light_cruiser;
	BOOL	m_new_heavy_cruiser;
	BOOL	m_war_destroyer;
	BOOL	m_gorn;
	BOOL	m_hydran;
	BOOL	m_isc;
	BOOL	m_klingon;
	BOOL	m_lyran;
	BOOL	m_mirak;
	BOOL	m_monster;
	BOOL	m_orion;
	BOOL	m_romulan;

#ifdef OP
	BOOL	m_OrionOrion;
	BOOL	m_Beastraiders;
	BOOL	m_WyldeFire;
	BOOL	m_Korgath;
	BOOL	m_Tigerheart;
	BOOL	m_Camboro;
	BOOL	m_Syndicate;
	BOOL	m_Prime;


	BOOL	m_X1_support;
	BOOL	m_Xship_proportional;
	BOOL	m_upgrade_AI_fighters;
#endif

	CString	m_race_use;
	int		m_ai_intel;

	/*
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCoopCustomizerDlg)
	*/
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	/*
	// Generated message map functions
	//{{AFX_MSG(CCoopCustomizerDlg)
	*/

	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDefaults();
	afx_msg void OnSelchangeRaceuse();
	virtual void OnOK();
	afx_msg void OnReleasedcaptureSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCartels();
	afx_msg void OnBattleship();
	afx_msg void OnCarrier();
	afx_msg void OnDestroyer();
	afx_msg void OnDreadnought();
	afx_msg void OnFrigate();
	afx_msg void OnHeavybattlecruiser();
	afx_msg void OnHeavycruiser();
	afx_msg void OnLightcruiser();
	afx_msg void OnNewheavycruiser();
	afx_msg void OnWardestroyer();
	afx_msg void OnMonster();

#ifdef OP
	afx_msg void OnX1_support();
	afx_msg void OnXship_proportional();
#endif

	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COOPCUSTOMIZERDLG_H__1481F34C_C890_461F_8CA8_4AD046F3C5B4__INCLUDED_)
