//	<Legal>	Copyright (c)  by Taldren, Inc. ALL RIGHTS RESERVED.
//	This document contains CONFIDENTIAL, PROPRIETARY, TRADE SECRET information
//	belonging to Taldren, Inc. and may not be reproduced, in whole
//	or in part, without prior written permission from Taldren, Inc.
//
//	<Info>	enums for races
//


#if !defined( Race_h )
#define Race_h

// This MUST match the nMetaMap::ePoliticalControl enum
enum eRace
{ 
	kUndefinedRace	= -2, 
	kNoRaceType = -1,

	kFirstRace = 0,
	
	//Active races
	kFederation = 0, 
	kKlingon,
	kRomulan,
	kLyran,
	kHydran,
	kGorn,
	kISC,
	kMirak,
	
	// Orion Races
	kOrionOrion,
	kOrionKorgath,
	kOrionPrime,
	kOrionTigerHeart,
	kOrionBeastRaiders,
	kOrionSyndicate,
	kOrionWyldeFire,
	kOrionCamboro,

	kOrion,
	kMonster,
	
	kNumActiveRaces,
	kNumPlayableRaces = kOrionCamboro + 1,
	
	kFirstNPCRace = kOrion,
	kLastNPCRace = kMonster,

	kFirstEmpireRace = kFederation,
	kLastEmpireRace = kMirak,

	kFirstCartelRace = kOrionOrion,
	kLastCartelRace = kOrionCamboro,

	//Non-Playable races
	kTholian = kLastNPCRace + 1,
	kLDR,
	kWYN,
	kJindarian,
	kAndro,
	
	//Other
	kNeutralRace,
	kMirror,
	kNumberOfRaces,

	//Special
	kAllRaces = kMirror + 1,
	kNoRace,

	kNumberOfRaceNames = kAllRaces + 1,
	
	_eRace_pad_to_long = 0x7FFFFFFF
};

typedef eRace eRaceName;

extern const char*	gRaceNames[kNumberOfRaceNames];
extern const char*	gFullRaceNames[kNumberOfRaceNames];
extern const char	gRacePrefix[kNumberOfRaceNames];
extern const char*	gRaceNamesPlural[kNumberOfRaceNames];


#endif // !defined( Race_h )

