//	<Name>	tcglue.h

//	<Legal>	Copyright (c) 1997 by Quicksilver Software, Inc. ALL RIGHTS RESERVED.
//	This document contains CONFIDENTIAL, PROPRIETARY, TRADE SECRET information
//	belonging to Quicksilver Software, Inc. and may not be reproduced, in whole
//	or in part, without prior written permission from Quicksilver Software, Inc.

//	<Info>	interface to some (but not all) commonly used C library routines.
//			should be completely platform independent
//			although minor tweaks are to be expected inside the implementation.

#pragma once

#ifndef	tcglue_h
#define	tcglue_h	1

#include "tlearn.h"
#include "tbasic.h"

#if ( __MWERKS__ >= 0x2200 )
#	include <climits>
#endif

//	#include <stddef.h>	// rbarris sez shouldn't need this here

// qualifications for being included in the clib glue:
// 1. stateless (no side effects)
// 2. available or implementable on all targets
// 3. expressible in terms of basic types (*without reference to the C runtime headers*)

class	clib
{
	public:

		typedef unsigned size_t;

		static	void	memset( void *destPtr, int8u value, iCount count );
		static  void	*memcpy( void *dest, const void *src, size_t count );
		static  int		memcmp( void *dest, const void *src, size_t count );
		static	void	strcpy( char *dest, const char *source);
		static	iCount	strlen( const char *string );

};

#endif

// <History>
// 05Feb97	rbarris		Created.
// 30May97	mhertogh	added memcpy
// 31May97	gshackel	added size_t typedef so it would compile
// 03Feb98  gmarster	added strcpy
// 03Sep98	mgerard		added climits support for MWPro4
// 09Nov98	mgerard		Added memcmp

