//	<Name>	tclient.h

//	<Legal>	Copyright (c) 1997 by Quicksilver Software, Inc. ALL RIGHTS RESERVED.
//	This document contains CONFIDENTIAL, PROPRIETARY, TRADE SECRET information
//	belonging to Quicksilver Software, Inc. and may not be reproduced, in whole
//	or in part, without prior written permission from Quicksilver Software, Inc.

//	<Info>	provides access to non-platform-specific headers and stuff (STL, etc)
//			also brings in tlearn/tbasic etc.
//			Makes a good replacement for the usual "tlearn, tbasic, STL, etc" verbiage.


// if tnative_h is defined, no tclient work is needed
// since tnative is defined to be a superset of tclient.

#if defined(__MWERKS__)	// Metrowerks symbol
	#ifndef	tnative_h
		#ifndef	tclient_h
			// Metrowerks builders should have tclient.pch in their project window,
			// tclient.pch begets each of the binary header outputs below as needed.
			
			#if __POWERPC__	// Metrowerks symbol
			  #include "tclient_PPC.prh"		// include binary precompiled header
			#endif
			
			#if __MC68K__	// Metrowerks symbol
			  #include "tclient_68K.prh"		// include binary precompiled header
			#endif
			
			#if __INTEL__	// Metrowerks symbol
			  #include "tclient_X86.prh"		// include binary precompiled header
			#endif
			
			#pragma once
		#endif
	#endif

#elif	defined(__BORLANDC__) || defined(_MSC_VER) || defined(__WATCOM__)

	#if defined(_MSC_VER)
		#pragma warning( disable: 4068 4786 4114 )	// Also turn off warnings for "Identifier was truncated to '255' characters in the browser information"
	#endif											// and "same type qualifier used more than once"

	#include	"tlearn.h"
	#include	"tbasic.h"
	#include	"tigerstl.h"
	#include	"tcglue.h"
	
	#if defined(__BORLANDC__) || defined(_MSC_VER)
		#pragma hdrstop								// Stop including files into the PCH
	#endif

#else
	#error	Unrecognized compiler.
#endif


// <History>
// 20Jun97	rbarris	Started.