/********************************************************************************************************\

	File Name:	HumanTeam.cpp
	Descript:	<DESCRIPTION>

\********************************************************************************************************/

#include "tclient.h"
#include "CommonDefs.h"
#include "HumanTeam.h"
#include "HumanTeamBaseState.h"
#include "HumanTeamBaseVictory.h"
#include "MissionText.h"
#include "ShipScriptDescription.h"
#include "Mul_CoopAce.h"

tClassAllocator<tHumanTeam> gHumanTeamAllocator;

void tHumanTeam::mSetupVictoryCondition()
{
	fVictoryCondition = new tHumanTeamBaseVictory( this );
	gEventMgr.mRegisterActor( fVictoryCondition );
}

void tHumanTeam::mSetupDebriefingList( eVictoryLevels victoryLevel )
{
//	fMissionInfo->mDebugMessage("tHumanTeam::mSetupDebriefingList");
	
	switch ( victoryLevel )
	{
	case kAstoundingVictory:
	case kVictory:
		fMissionInfo->mAddToDebriefingList( fTeam, kWinner_msg );		break;
	case kDevastatingDefeat:
	case kDefeat:
		fMissionInfo->mAddToDebriefingList( fTeam, kLoser_msg );		break;
	case kUnknownVictoryLevel:
		fMissionInfo->mAddToDebriefingList( fTeam, kLeftEarly_msg );	break;
	case kDraw:
	default:
		fMissionInfo->mAddToDebriefingList( fTeam, kDefault_msg );		break;
	}
}

void tHumanTeam::mSetupState()
{
	// The non hosts don't have any startups to complete.. soo..
	if (!gScriptInterface.mIsHost()) {
		completed_startup = 1;
	}
	mRegisterState( new tHumanTeamBaseState() );
	mGotoState( typeid( tHumanTeamBaseState ) );
}

void tHumanTeam::mSetupCommState()
{}

void tHumanTeam::mCreateShipsForTeam()
{}

void tHumanTeam::mTeamSetupComplete()
{
	tTeamInfo::mTeamSetupComplete();
}


void tHumanTeam::mCreateNewShip( const tShipScriptDescription& shipScriptDescription )
{
	pscnl.push_back(shipScriptDescription.fClassName);

	if (gScriptInterface.mIsHost()) {
		Ship aShip;

		// Make sure we have a shiplist by now.
		if (global_sl.size() == 0) {
#ifdef OP
			global_sl.CreateMaster(ShipList::kOrionPirates, false);
#else
			global_sl.CreateMaster(ShipList::kEmpiresAtWar, false);
#endif
		}

		global_sl.Find(shipScriptDescription.fClassName.c_str(), aShip);
		selected_human_sl.push_back(aShip);
	}
	
	mCreateShip( typeid( tShipInfo ), 
				 shipScriptDescription.fClassName.c_str(), 
				 kStartPosition_G + shipScriptDescription.fTeamID,
				 kNoMetaShipID,
				 -1, 0, 0, -1, -1,
				 shipScriptDescription.fCustomName.c_str(),
				 static_cast< eShipOptions >( kDefaultShipOptions | kCanBeCarrier | kDeathUponCapture )
				 );
}



